/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1998, ADLink Technology Inc.  All rights reserved.  ;;
;;									   ;;
;;	File Name   :	DI_DEMO1.C					   ;;
;;	Purpose     :	Demo program of PCI-7432 digital input		   ;;
;;	Date	    :	4/28/1998					   ;;
;;	Revision    :	1.00						   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
//#include "aclerr.h"
#include "std.h"
#include "video.h"
#include "key.h"
#include "acl_pci.H"

#define ACL_TitleColor	    (WHITE | bgcolor(GREEN))
#define ACL_TextColor	    (WHITE | bgcolor(BLUE))
#define ACL_BkColor	    (BLUE | bgcolor(BLUE))
#define ACL_MsgColor	    (RED|INVERSE)
#define ACL_ProgColor	    (WHITE | bgcolor(BROWN))


U8  *acl_Title = "****** PCI-7432 DI DEMO (Single) ******";
U8  *acl_Copyright="Copyright (c) 1995-1997, ADLink Technology Inc.  All rights reserved.";

/*----------------------------------------------------------------------*/

void showMessage(std_UByte *msg)
{
    video_ClearBox(24, 0, 24, 79, INVERSE);
    video_CenterPutStr(24, msg, ACL_MsgColor);
}
/*----------------------------------------------------------------------*/

void main( void )
{
    I16     i, j, err, row, col, key;
    U32	    diData, tmpBuf[80];
    U16     existCards, curCardNo;
    PCI_INFO	    info;
	U32	bn;


    /*---------- PCI-7432 initial ------------------------------------------*/
    err = _7432_Initial(&existCards, &info);
    if(err != ERR_NoError) {
	printf("PCI BIOS does not exist\n");
	exit(1);
    }
    if(existCards == 0) {
	printf("PCI-7432 does not exist\n");
	exit(1);
    }

	/*----------------------------------------------------------------------*/
    video_Initial();
    video_CursorOff();
    video_Box(VIDEO_SINGLE, 0, 0,  4, 79, ACL_TitleColor);
    video_Box(VIDEO_DOUBLE, 5, 0, 23, 79, ACL_TextColor);
    video_ClearBox(24, 0, 24, 79, INVERSE | BLUE);
    video_CenterPutStr(1, acl_Title, ACL_TitleColor);
    video_CenterPutStr(3, acl_Copyright, ACL_TitleColor);
    showMessage(">>> Press <Esc> to quit <<<");
    row = 10;
    col = 20;
    video_PutStr(row,  col, "PCI-7432 input DI_PORT0 =", ACL_TextColor);

    curCardNo = PCI_CARD1;
	_7432_Software_Reset(curCardNo);

    _7432_DI(curCardNo, &diData);	 // DI for PCI-7432
    sprintf(tmpBuf,"%08lX", diData);
    video_PutStr(row, col+30, tmpBuf, INVERSE);

    key = !KEY_ESC;
    do {
	 if(key_Hit())  key = key_Get();
	 _7432_DI(curCardNo, &diData);
	 sprintf(tmpBuf, "%08lX", diData);
	 video_PutStr(row, col+30, tmpBuf, INVERSE);
    } while(key != KEY_ESC);
    video_CursorOn();
    video_ClearBox(24, 0, 24, 79, NORMAL);
}
